var arr_day_of_week = ['Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa', 'So']; // День недели

function weekday(y, m, d) {
  var d = new Date(y, m, d); // Новый объект даты
  return d.getDay(); // Получаем день недели
}

// Добавляем заголовок id - куда будет добавлен
function draw_header(id, day_of_week, begin_day) {
  var el = document.getElementById(id); // получаем Id куда будет добавлен новый элемент т.е. заголовок
  var elheader = document.createElement('div'); // Новый элемент для заголовка
  elheader.style.position = 'relative'; // Позиция относительная
  elheader.style.left = '80px'; 
  elheader.style.top = '2px';
  el.appendChild(elheader); // Добавляем
  day_of_week--; // Вычитаем день недели чтобы правильно отобразить
  var posx = 0; 
  // Цикл на 7 дней...
  for(var i=0; i<7; i++) {
    var el_new = document.createElement('div');
    el_new.id = id + '_h' + i;
    if(day_of_week >= arr_day_of_week.length) day_of_week = 0;
    el_new.innerHTML = '&nbsp;' + arr_day_of_week[day_of_week] + '&nbsp;' + begin_day + '&nbsp;';
    el_new.style.position = 'absolute';
    el_new.style.top = '0px';
    el_new.style.left = posx + 'px';
    posx+=70;
    el_new.style.borderLeft = '1px solid #eee';
    el_new.style.borderBottom = '1px solid #eee';
    el_new.style.display = 'inline-block';
    if(i >= 6) el_new.style.borderRight = '1px solid #eee';
    el_new.style.width = '70px';
    el_new.style.height = '40px';
    el_new.style.textAlign = 'center';
    begin_day++;
    day_of_week++;
    elheader.appendChild(el_new);
  }
}

// Добавляем часы
function draw_timeline(id) {
  var el = document.getElementById(id);
  var eltimeline = document.createElement('div');
  eltimeline.style.position = 'relative';
  eltimeline.style.left = '10px';
  eltimeline.style.top = '2px';
  var begin_time = 7;
  var posy = 40;
  for(var i=0; i<24; i++) {
     var el_new = document.createElement('div');
     el_new.id = id + '_t' + begin_time; 
     el_new.innerHTML = (begin_time < 10 ? '0'+begin_time : begin_time) + ':00'; // Если время меньше 10 то добавляем 0
     el_new.style.position = 'absolute'; // Позиция абсолютная
     el_new.style.top = posy + 'px'; 
     el_new.style.left = '0px';
     posy+=30;
     el_new.style.width = '70px';
     if(i == 0) el_new.style.borderTop = '1px solid #eee'; // Если сверху то вверху линия

     el_new.style.borderBottom = '1px solid #eee';
     el_new.style.borderRight = '1px solid #eee';
     el_new.style.textAlign = 'right';
     el_new.style.height = '30px';
     begin_time++;
     eltimeline.appendChild(el_new); // Добавляем элементы
  }
  el.appendChild(eltimeline); // Добавляем время 
}

// Рисуем время id это id календаря, text - это текст, часы, и день недели
function draw_item(id, text, hour, day) {
  var el_time = document.getElementById(id + '_t' + hour);
  var el_head = document.getElementById(id + '_h' + day);
  var el = document.getElementById(id);
  var new_el = document.createElement('div');

  new_el.style.position = 'absolute';
  new_el.style.left = el_head.style.left;
  new_el.style.top = el_time.style.top;
  new_el.style.width = '70px';
  new_el.style.height = '30px';
  new_el.innerHTML = text;

  el.appendChild(new_el);
}

class Calendar {

  constructor(id, day, month, year) {
    this.id = id;
    this.day = day;
    this.month = month;
    this.year = year;
  }

  add_item(text, hour, day) {
    draw_item(this.id, text, hour, day);
  }

  draw() {
    draw_header(this.id, weekday(this.year, this.month, this.day), this.day);
    draw_timeline(this.id);
  }

}